<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\ClassCharacteristic;
use App\Models\User;

class ClassCharacteristicPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any ClassCharacteristic');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, ClassCharacteristic $classcharacteristic): bool
    {
        return $user->checkPermissionTo('view ClassCharacteristic');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create ClassCharacteristic');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, ClassCharacteristic $classcharacteristic): bool
    {
        return $user->checkPermissionTo('update ClassCharacteristic');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, ClassCharacteristic $classcharacteristic): bool
    {
        return $user->checkPermissionTo('delete ClassCharacteristic');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any ClassCharacteristic');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, ClassCharacteristic $classcharacteristic): bool
    {
        return $user->checkPermissionTo('restore ClassCharacteristic');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any ClassCharacteristic');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, ClassCharacteristic $classcharacteristic): bool
    {
        return $user->checkPermissionTo('replicate ClassCharacteristic');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder ClassCharacteristic');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, ClassCharacteristic $classcharacteristic): bool
    {
        return $user->checkPermissionTo('force-delete ClassCharacteristic');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any ClassCharacteristic');
    }
}
